找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1903|回复: 10

[求助] 请问如何提取实体的边?

[复制链接]
发表于 2016-7-26 21:23:52 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
请问如何提取实体的边?实现XEDGES这个命令的功能
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 859个

财富等级: 财运亨通

发表于 2016-7-26 22:36:03 来自手机 | 显示全部楼层
查手册中 AcBrep 类

点评

我大概知道是用Autodesk.AutoCAD.BoundaryRepresentation的Edge中的GetCurveAsNurb(),就是没搞明白怎么用  详情 回复 发表于 2016-7-26 23:16
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 2016-7-26 23:16:01 | 显示全部楼层
csharp 发表于 2016-7-26 22:36
查手册中 AcBrep 类

我大概知道是用Autodesk.AutoCAD.BoundaryRepresentation的Edge中的GetCurveAsNurb(),就是没搞明白怎么用

点评

给你贴段代码,选择3DSOLID的子实体的,你可以参照下看看.NET如何操作BREP类 The following command illustrates a way to prompt user for subentity selection on a solid3d. It allows to select a single s  详情 回复 发表于 2016-7-26 23:39
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 6个

财富等级: 恭喜发财

发表于 2016-7-26 23:39:51 | 显示全部楼层
taocitc 发表于 2016-7-26 23:16
我大概知道是用Autodesk.AutoCAD.BoundaryRepresentation的Edge中的GetCurveAsNurb(),就是没搞明白怎么用

给你贴段代码,选择3DSOLID的子实体的,你可以参照下看看.NET如何操作BREP类


The following command illustrates a way to prompt user for subentity selection on a solid3d. It allows to select a single subentity and checks if the selected subentity type matches the specified type.
After the subentity has been selected, it uses the Brep API and retrieve the Brep entity representing this subentity. Further methods of the Brep object can be invoked in order to analyze the properties of the subentity.


  1. [CommandMethod("SubEntSelectBrep")]
  2. public void SubEntSelectBrep()
  3. {
  4.     Document doc = Application.DocumentManager.MdiActiveDocument;
  5.     Database db = doc.Database;
  6.     Editor ed = doc.Editor;

  7.     PromptKeywordOptions pko = new PromptKeywordOptions(
  8.         "\nSpecify sub-entity selection type:");
  9.     pko.AllowNone = false;
  10.     pko.Keywords.Add("Face");
  11.     pko.Keywords.Add("Edge");
  12.     pko.Keywords.Add("Vertex");
  13.     pko.Keywords.Default = "Face";

  14.     PromptResult pkr = ed.GetKeywords(pko);

  15.     if (pkr.Status != PromptStatus.OK)
  16.         return;

  17.     SubentityType subentityType = SubentityType.Null;

  18.     switch(pkr.StringResult)
  19.     {
  20.         case "Face":
  21.             subentityType = SubentityType.Face;
  22.             break;
  23.         case "Edge":
  24.             subentityType = SubentityType.Edge;
  25.             break;
  26.         case "Vertex":
  27.             subentityType = SubentityType.Vertex;
  28.             break;
  29.         default:
  30.             return;
  31.     }

  32.     PromptSelectionOptions pso = new PromptSelectionOptions();
  33.     pso.MessageForAdding = "\nSelect solid " +
  34.         pkr.StringResult + ": ";
  35.     pso.SingleOnly = true;
  36.     pso.SinglePickInSpace = true;
  37.     pso.ForceSubSelections = true;

  38.     PromptSelectionResult psr = ed.GetSelection(pso);

  39.     if (psr.Status != PromptStatus.OK)
  40.         return;

  41.     SelectionSet ss = psr.Value;

  42.     SelectedObject so = ss[0];

  43.     if (!so.ObjectId.ObjectClass.IsDerivedFrom(
  44.         RXClass.GetClass(typeof(Solid3d))))
  45.     {
  46.         ed.WriteMessage(
  47.             "\nYou didn't select a solid, please try again...");
  48.         return;
  49.     }

  50.     using (Transaction Tx = db.TransactionManager.StartTransaction())
  51.     {
  52.         Solid3d solid = Tx.GetObject(so.ObjectId, OpenMode.ForRead)
  53.             as Solid3d;

  54.         SelectedSubObject[] sso = so.GetSubentities();

  55.         //Checks that selected type matches keyword selection
  56.         if (subentityType != sso[0].FullSubentityPath.SubentId.Type)
  57.         {
  58.             ed.WriteMessage("\nInvalid Subentity Type: " +
  59.                 sso[0].FullSubentityPath.SubentId.Type +
  60.                 ", please try again...");
  61.             return;
  62.         }

  63.         SubentityId subentityId = sso[0].FullSubentityPath.SubentId;

  64.         //Creates subentity path to use with GetSubentity
  65.         FullSubentityPath subEntityPath = new FullSubentityPath(
  66.             new ObjectId[] { solid.ObjectId },
  67.             subentityId);

  68.         //Returns a non-database resident entity
  69.         //that represents the subentity
  70.         using (Entity entity = solid.GetSubentity(subEntityPath))
  71.         {
  72.             ed.WriteMessage("\nSubentity Entity Type: "
  73.                 + entity.ToString());
  74.         }

  75.         //Creates entity path to generate Brep object from it
  76.         FullSubentityPath entityPath = new FullSubentityPath(
  77.             new ObjectId[] { solid.ObjectId },
  78.             new SubentityId(SubentityType.Null, IntPtr.Zero));

  79.         using (Brep brep = new Brep(entityPath))
  80.         {
  81.             switch (subentityType)
  82.             {
  83.                 case SubentityType.Face:

  84.                     foreach (
  85.                         Autodesk.AutoCAD.BoundaryRepresentation.Face
  86.                             face in brep.Faces)
  87.                     {
  88.                         if (subentityId ==
  89.                             face.SubentityPath.SubentId)
  90.                         {
  91.                             ed.WriteMessage("\nSu**ce: "
  92.                                 + face.Su**ce.ToString());

  93.                             break;
  94.                         }
  95.                     }
  96.                     break;

  97.                 case SubentityType.Edge:

  98.                     foreach (
  99.                         Autodesk.AutoCAD.BoundaryRepresentation.Edge
  100.                            edge
  101.                         in brep.Edges)
  102.                     {
  103.                         if (subentityId ==
  104.                             edge.SubentityPath.SubentId)
  105.                         {
  106.                             ed.WriteMessage("\nCurve: " +
  107.                                 edge.Curve.ToString());

  108.                             break;
  109.                         }
  110.                     }
  111.                     break;

  112.                 case SubentityType.Vertex:

  113.                     foreach (
  114.                        Autodesk.AutoCAD.BoundaryRepresentation.Vertex
  115.                            vertex
  116.                         in brep.Vertices)
  117.                     {
  118.                         if (subentityId ==
  119.                             vertex.SubentityPath.SubentId)
  120.                         {
  121.                             ed.WriteMessage("\nPoint: " +
  122.                                 PointToStr(vertex.Point));

  123.                             break;
  124.                         }
  125.                     }
  126.                     break;

  127.                 default:
  128.                     break;
  129.             }
  130.         }

  131.         Tx.Commit();
  132.     }
  133. }


游客,如果您要查看本帖隐藏内容请回复

点评

现在倒是能获取到边了,也能给这些边改个颜色了,可是怎么获取这些边的曲线的类型,并根据不同的类型生成实体呢? ObjectId[] ids = new ObjectId[] { solid.ObjectId }; Subent  详情 回复 发表于 2016-7-29 13:01
谢谢提供代码,我琢磨琢磨  详情 回复 发表于 2016-7-27 21:13
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 3913个

财富等级: 富可敌国

发表于 2016-7-27 08:08:09 | 显示全部楼层
回复学习学习!:lol
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 2016-7-27 21:13:46 | 显示全部楼层
CSharpBoy 发表于 2016-7-26 23:39
给你贴段代码,选择3DSOLID的子实体的,你可以参照下看看.NET如何操作BREP类

谢谢提供代码,我琢磨琢磨
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

 楼主| 发表于 2016-7-29 13:01:47 | 显示全部楼层
本帖最后由 taocitc 于 2016-7-29 23:15 编辑

谢谢,终于搞定这个问题了。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1个

财富等级: 恭喜发财

发表于 2017-6-27 21:07:46 | 显示全部楼层
学习学习了,,,,,,,,,,,,,,,,,
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1个

财富等级: 恭喜发财

发表于 2017-7-1 07:01:36 | 显示全部楼层

大神,,,这代码怎么用的,出错不知道怎么处理呀 ,
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2个

财富等级: 恭喜发财

发表于 2018-11-24 10:38:38 | 显示全部楼层
谢谢老板,参考参考代码
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2020-9-21 18:31:35 | 显示全部楼层
666666666666666
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 21:43 , Processed in 0.282943 second(s), 52 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表